diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet-apps/examples/ping-example.cc ns-3.38/src/internet-apps/examples/ping-example.cc
--- ns-3.37/src/internet-apps/examples/ping-example.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/src/internet-apps/examples/ping-example.cc	2023-03-16 20:54:23.608868600 -0700
@@ -0,0 +1,264 @@
+/*
+ * Copyright (c) 2022 Chandrakant Jena
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Chandrakant Jena <chandrakant.barcelona@gmail.com>
+ */
+
+// Example to demonstrate the working of the Ping Application
+// Network topology:
+// A ------------------------------ B ------------------------------ C
+//             100 Mbps                           100 Mbps
+//               5 ms (one way)                     5 ms (one way)
+// IPv4 addresses:
+// 10.1.1.1    <->         10.1.1.2 / 10.1.2.1     <->         10.1.2.2
+//
+// IPv6 addresses:
+// 2001:1::200:ff:fe00:1
+//     <->    2001:1::200:ff:fe00:2 / 2001:1:0:1:200:ff:fe00:3
+//                                       <-> 2001:1:0:1:200:ff:fe00:4
+//
+// The topology has three nodes interconnected by two point-to-point links.
+// Each link has 5 ms one-way delay, for a round-trip propagation delay
+// of 20 ms.  The transmission rate on each link is 100 Mbps.  The routing
+// between links is enabled by ns-3's NixVector routing.
+//
+// By default, this program will send 5 pings from node A to node C using IPv6.
+// When using IPv6, the output will look like this:
+//
+// PING 2001:1:0:1:200:ff:fe00:4 - 56 bytes of data; 104 bytes including ICMP and IPv6 headers.
+// 64 bytes from (2001:1:0:1:200:ff:fe00:4): icmp_seq=0 ttl=63 time=20.033 ms
+// 64 bytes from (2001:1:0:1:200:ff:fe00:4): icmp_seq=1 ttl=63 time=20.033 ms
+// 64 bytes from (2001:1:0:1:200:ff:fe00:4): icmp_seq=2 ttl=63 time=20.033 ms
+// 64 bytes from (2001:1:0:1:200:ff:fe00:4): icmp_seq=3 ttl=63 time=20.033 ms
+// 64 bytes from (2001:1:0:1:200:ff:fe00:4): icmp_seq=4 ttl=63 time=20.033 ms
+//
+// --- 2001:1:0:1:200:ff:fe00:4 ping statistics ---
+// 5 packets transmitted, 5 received, 0% packet loss, time 4020ms
+// rtt min/avg/max/mdev = 20/20/20/0 ms
+//
+// When using IPv4, the output will look like this:
+//
+//   PING 10.1.2.2 - 56 bytes of data; 84 bytes including ICMP and IPv4 headers.
+//   64 bytes from (10.1.2.2): icmp_seq=0 ttl=63 time=20.027 ms
+//   64 bytes from (10.1.2.2): icmp_seq=1 ttl=63 time=20.027 ms
+//   64 bytes from (10.1.2.2): icmp_seq=2 ttl=63 time=20.027 ms
+//   64 bytes from (10.1.2.2): icmp_seq=3 ttl=63 time=20.027 ms
+//   64 bytes from (10.1.2.2): icmp_seq=4 ttl=63 time=20.027 ms
+//   --- 10.1.2.2 ping statistics ---
+//   5 packets transmitted, 5 received, 0% packet loss, time 4020ms
+//   rtt min/avg/max/mdev = 20/20/20/0 ms
+//
+// The example program will also produce four pcap traces (one for each
+// NetDevice in the scenario) that can be viewed using tcpdump or Wireshark.
+//
+// Other program options include options to change the destination and
+// source addresses, number of packets (count), packet size, interval,
+// and whether to enable logging (if logging is enabled in the build).
+//
+// The Ping application in this example starts at simulation time 1 and will
+// stop either at simulation time 50 or once 'Count' pings have been responded
+// to, whichever comes first.
+
+#include "ns3/core-module.h"
+#include "ns3/internet-apps-module.h"
+#include "ns3/internet-module.h"
+#include "ns3/network-module.h"
+#include "ns3/nix-vector-routing-module.h"
+#include "ns3/point-to-point-module.h"
+
+#include <fstream>
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE("PingExample");
+
+int
+main(int argc, char* argv[])
+{
+    bool logging{false};
+    Time interPacketInterval{Seconds(1.0)};
+    uint32_t size{56};
+    uint32_t count{5};
+    std::string destinationStr;
+    Address destination;
+    std::string sourceStr;
+    Address source;
+    bool useIpv6{true};
+
+    GlobalValue::Bind("ChecksumEnabled", BooleanValue(true));
+
+    CommandLine cmd(__FILE__);
+    cmd.AddValue("logging", "Tell application to log if true", logging);
+    cmd.AddValue("interval", "The time to wait between two packets", interPacketInterval);
+    cmd.AddValue("size", "Data bytes to be sent, per-packet", size);
+    cmd.AddValue("count", "Number of packets to be sent", count);
+    cmd.AddValue("destination",
+                 "Destination IPv4 or IPv6 address, e.g., \"10.1.2.2\"",
+                 destinationStr);
+    cmd.AddValue("source",
+                 "Source address, needed only for multicast or broadcast destinations",
+                 sourceStr);
+    cmd.Parse(argc, argv);
+
+    if (!destinationStr.empty())
+    {
+        Ipv4Address v4Dst = Ipv4Address(destinationStr.c_str());
+        Ipv6Address v6Dst = Ipv6Address(destinationStr.c_str());
+        if (v4Dst.IsInitialized())
+        {
+            useIpv6 = false;
+            destination = v4Dst;
+        }
+        else if (v6Dst.IsInitialized())
+        {
+            useIpv6 = true;
+            destination = v6Dst;
+        }
+    }
+
+    if (!sourceStr.empty())
+    {
+        Ipv4Address v4Src = Ipv4Address(sourceStr.c_str());
+        Ipv6Address v6Src = Ipv6Address(sourceStr.c_str());
+        if (v4Src.IsInitialized())
+        {
+            source = v4Src;
+        }
+        else if (v6Src.IsInitialized())
+        {
+            source = v6Src;
+        }
+    }
+    if (sourceStr.empty())
+    {
+        if (useIpv6)
+        {
+            Ipv6Address v6Dst = Ipv6Address(destinationStr.c_str());
+            if (v6Dst.IsInitialized() && v6Dst.IsMulticast())
+            {
+                std::cout << "Specify a source address to use when pinging multicast addresses"
+                          << std::endl;
+                std::cout << "Program exiting..." << std::endl;
+                return 0;
+            }
+        }
+        else
+        {
+            Ipv4Address v4Dst = Ipv4Address(destinationStr.c_str());
+            if (v4Dst.IsInitialized() && (v4Dst.IsBroadcast() || v4Dst.IsMulticast()))
+            {
+                std::cout << "Specify a source address to use when pinging broadcast or multicast "
+                             "addresses"
+                          << std::endl;
+                std::cout << "Program exiting..." << std::endl;
+                return 0;
+            }
+        }
+    }
+
+    if (logging)
+    {
+        LogComponentEnableAll(LogLevel(LOG_PREFIX_TIME | LOG_PREFIX_NODE));
+        LogComponentEnable("Ping", LOG_LEVEL_ALL);
+    }
+
+    NodeContainer nodes;
+    nodes.Create(3);
+    NodeContainer link1Nodes;
+    link1Nodes.Add(nodes.Get(0));
+    link1Nodes.Add(nodes.Get(1));
+    NodeContainer link2Nodes;
+    link2Nodes.Add(nodes.Get(1));
+    link2Nodes.Add(nodes.Get(2));
+
+    PointToPointHelper pointToPoint;
+    pointToPoint.SetDeviceAttribute("DataRate", StringValue("100Mbps"));
+    pointToPoint.SetChannelAttribute("Delay", StringValue("5ms"));
+
+    NetDeviceContainer link1Devices;
+    link1Devices = pointToPoint.Install(link1Nodes);
+    NetDeviceContainer link2Devices;
+    link2Devices = pointToPoint.Install(link2Nodes);
+
+    // The following block of code inserts an optional packet loss model
+    Ptr<PointToPointNetDevice> p2pSender = DynamicCast<PointToPointNetDevice>(link1Devices.Get(0));
+    Ptr<ReceiveListErrorModel> errorModel = CreateObject<ReceiveListErrorModel>();
+    std::list<uint32_t> dropList;
+    // Enable one or more of the below lines to force specific packet losses
+    // dropList.push_back (0);
+    // dropList.push_back (1);
+    // dropList.push_back (2);
+    // dropList.push_back (3);
+    // dropList.push_back (4);
+    // etc. (other lines may be added)
+    errorModel->SetList(dropList);
+    p2pSender->SetReceiveErrorModel(errorModel);
+
+    if (!useIpv6)
+    {
+        Ipv4NixVectorHelper nixRouting;
+        InternetStackHelper stack;
+        stack.SetRoutingHelper(nixRouting);
+        stack.SetIpv6StackInstall(false);
+        stack.Install(nodes);
+
+        Ipv4AddressHelper addressV4;
+        addressV4.SetBase("10.1.1.0", "255.255.255.0");
+        addressV4.Assign(link1Devices);
+        addressV4.NewNetwork();
+        Ipv4InterfaceContainer link2InterfacesV4 = addressV4.Assign(link2Devices);
+
+        if (destination.IsInvalid())
+        {
+            destination = link2InterfacesV4.GetAddress(1, 0);
+        }
+    }
+    else
+    {
+        Ipv6NixVectorHelper nixRouting;
+        InternetStackHelper stack;
+        stack.SetRoutingHelper(nixRouting);
+        stack.SetIpv4StackInstall(false);
+        stack.Install(nodes);
+
+        Ipv6AddressHelper addressV6;
+        addressV6.SetBase("2001:1::", 64);
+        addressV6.Assign(link1Devices);
+        addressV6.NewNetwork();
+        Ipv6InterfaceContainer link2InterfacesV6 = addressV6.Assign(link2Devices);
+
+        if (destination.IsInvalid())
+        {
+            destination = link2InterfacesV6.GetAddress(1, 1);
+        }
+    }
+
+    // Create Ping application and installing on node A
+    PingHelper pingHelper(destination, source);
+    pingHelper.SetAttribute("Interval", TimeValue(interPacketInterval));
+    pingHelper.SetAttribute("Size", UintegerValue(size));
+    pingHelper.SetAttribute("Count", UintegerValue(count));
+    ApplicationContainer apps = pingHelper.Install(nodes.Get(0));
+    apps.Start(Seconds(1));
+    apps.Stop(Seconds(50));
+
+    pointToPoint.EnablePcapAll("ping-example");
+
+    Simulator::Stop(Seconds(60.0));
+    Simulator::Run();
+    Simulator::Destroy();
+    return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet-apps/examples/traceroute-example.cc ns-3.38/src/internet-apps/examples/traceroute-example.cc
--- ns-3.37/src/internet-apps/examples/traceroute-example.cc	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/internet-apps/examples/traceroute-example.cc	2023-03-16 20:54:23.608868600 -0700
@@ -236,7 +236,7 @@
     {
         Ptr<OutputStreamWrapper> routingStream =
             Create<OutputStreamWrapper>("aodv.routes", std::ios::out);
-        aodv.PrintRoutingTableAllAt(Seconds(8), routingStream);
+        Ipv4RoutingHelper::PrintRoutingTableAllAt(Seconds(8), routingStream);
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet-apps/helper/ping6-helper.cc ns-3.38/src/internet-apps/helper/ping6-helper.cc
--- ns-3.37/src/internet-apps/helper/ping6-helper.cc	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/internet-apps/helper/ping6-helper.cc	2023-03-16 20:54:23.608868600 -0700
@@ -21,6 +21,7 @@
 
 #include "ns3/ping6.h"
 #include "ns3/uinteger.h"
+#include "ns3/warnings.h"
 
 namespace ns3
 {
@@ -28,7 +29,9 @@
 Ping6Helper::Ping6Helper()
     : m_ifIndex(0)
 {
+    NS_WARNING_PUSH_DEPRECATED;
     m_factory.SetTypeId(Ping6::GetTypeId());
+    NS_WARNING_POP;
 }
 
 void
@@ -52,6 +55,9 @@
 ApplicationContainer
 Ping6Helper::Install(NodeContainer c)
 {
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
+
     ApplicationContainer apps;
     for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
     {
@@ -65,6 +71,8 @@
         apps.Add(client);
     }
     return apps;
+
+#pragma GCC diagnostic pop
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet-apps/helper/ping6-helper.h ns-3.38/src/internet-apps/helper/ping6-helper.h
--- ns-3.37/src/internet-apps/helper/ping6-helper.h	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/internet-apps/helper/ping6-helper.h	2023-03-16 20:54:23.608868600 -0700
@@ -40,6 +40,7 @@
     /**
      * \brief Constructor.
      */
+    NS_DEPRECATED_3_38("Use PingHelper instead - the attributes might have been renamed.")
     Ping6Helper();
 
     /**
@@ -74,6 +75,7 @@
      * when a node has multiple interfaces.
      * \param ifIndex interface index
      */
+    NS_DEPRECATED_3_38("Use a source address")
     void SetIfIndex(uint32_t ifIndex);
 
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet-apps/helper/ping-helper.cc ns-3.38/src/internet-apps/helper/ping-helper.cc
--- ns-3.37/src/internet-apps/helper/ping-helper.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/src/internet-apps/helper/ping-helper.cc	2023-03-16 20:54:23.608868600 -0700
@@ -0,0 +1,85 @@
+/*
+ * Copyright (c) 2022 Universita' di Firenze, Italy
+ * Copyright (c) 2008-2009 Strasbourg University (original Ping6 helper)
+ * Copyright (c) 2008 INRIA (original v4Ping helper)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Tommaso Pecorella <tommaso.pecorella@unifi.it>
+ *
+ * Derived from original v4Ping helper (author: Mathieu Lacage)
+ * Derived from original ping6 helper (author: Sebastien Vincent)
+ */
+
+#include "ping-helper.h"
+
+#include "ns3/names.h"
+#include "ns3/ping.h"
+
+namespace ns3
+{
+
+PingHelper::PingHelper()
+{
+    m_factory.SetTypeId("ns3::Ping");
+}
+
+PingHelper::PingHelper(Address remote, Address local)
+{
+    m_factory.SetTypeId("ns3::Ping");
+    m_factory.Set("Destination", AddressValue(remote));
+    m_factory.Set("InterfaceAddress", AddressValue(local));
+}
+
+void
+PingHelper::SetAttribute(std::string name, const AttributeValue& value)
+{
+    m_factory.Set(name, value);
+}
+
+ApplicationContainer
+PingHelper::Install(Ptr<Node> node) const
+{
+    return ApplicationContainer(InstallPriv(node));
+}
+
+ApplicationContainer
+PingHelper::Install(std::string nodeName) const
+{
+    Ptr<Node> node = Names::Find<Node>(nodeName);
+    return ApplicationContainer(InstallPriv(node));
+}
+
+ApplicationContainer
+PingHelper::Install(NodeContainer c) const
+{
+    ApplicationContainer apps;
+    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    {
+        apps.Add(InstallPriv(*i));
+    }
+
+    return apps;
+}
+
+Ptr<Application>
+PingHelper::InstallPriv(Ptr<Node> node) const
+{
+    Ptr<Ping> app = m_factory.Create<Ping>();
+    node->AddApplication(app);
+
+    return app;
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet-apps/helper/ping-helper.h ns-3.38/src/internet-apps/helper/ping-helper.h
--- ns-3.37/src/internet-apps/helper/ping-helper.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/src/internet-apps/helper/ping-helper.h	2023-03-16 20:54:23.608868600 -0700
@@ -0,0 +1,116 @@
+/*
+ * Copyright (c) 2022 Universita' di Firenze, Italy
+ * Copyright (c) 2008-2009 Strasbourg University (original Ping6 helper)
+ * Copyright (c) 2008 INRIA (original v4Ping helper)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Tommaso Pecorella <tommaso.pecorella@unifi.it>
+ *
+ * Derived from original v4Ping helper (author: Mathieu Lacage)
+ * Derived from original ping6 helper (author: Sebastien Vincent)
+ */
+
+#ifndef PING_HELPER_H
+#define PING_HELPER_H
+
+#include "ns3/application-container.h"
+#include "ns3/ipv4-address.h"
+#include "ns3/ipv6-address.h"
+#include "ns3/node-container.h"
+#include "ns3/object-factory.h"
+#include "ns3/ping.h"
+
+#include <stdint.h>
+
+namespace ns3
+{
+
+/**
+ * \ingroup ping
+ * \brief Create a ping application and associate it to a node
+ *
+ * This class creates one or multiple instances of ns3::Ping and associates
+ * it/them to one/multiple node(s).
+ */
+class PingHelper
+{
+  public:
+    /**
+     * Create a PingHelper which is used to make life easier for people wanting
+     * to use ping Applications.
+     */
+    PingHelper();
+
+    /**
+     * Create a PingHelper which is used to make life easier for people wanting
+     * to use ping Applications.
+     *
+     * \param remote The address which should be pinged
+     * \param local The source address
+     */
+    PingHelper(Address remote, Address local = Address());
+
+    /**
+     * Install a Ping application on each Node in the provided NodeContainer.
+     *
+     * \param nodes The NodeContainer containing all of the nodes to get a Ping
+     *              application.
+     *
+     * \returns A list of Ping applications, one for each input node
+     */
+    ApplicationContainer Install(NodeContainer nodes) const;
+
+    /**
+     * Install a Ping application on the provided Node.  The Node is specified
+     * directly by a Ptr<Node>
+     *
+     * \param node The node to install the Ping application on.
+     *
+     * \returns An ApplicationContainer holding the Ping application created.
+     */
+    ApplicationContainer Install(Ptr<Node> node) const;
+
+    /**
+     * Install a Ping application on the provided Node.  The Node is specified
+     * by a string that must have previously been associated with a Node using the
+     * Object Name Service.
+     *
+     * \param nodeName The node to install the Ping application on.
+     *
+     * \returns An ApplicationContainer holding the Ping application created.
+     */
+    ApplicationContainer Install(std::string nodeName) const;
+
+    /**
+     * \brief Configure ping applications attribute
+     * \param name   attribute's name
+     * \param value  attribute's value
+     */
+    void SetAttribute(std::string name, const AttributeValue& value);
+
+  private:
+    /**
+     * \brief Do the actual application installation in the node
+     * \param node the node
+     * \returns a Smart pointer to the installed application
+     */
+    Ptr<Application> InstallPriv(Ptr<Node> node) const;
+    /// Object factory
+    ObjectFactory m_factory;
+};
+
+} // namespace ns3
+
+#endif /* PING_HELPER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet-apps/helper/v4ping-helper.cc ns-3.38/src/internet-apps/helper/v4ping-helper.cc
--- ns-3.37/src/internet-apps/helper/v4ping-helper.cc	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/internet-apps/helper/v4ping-helper.cc	2023-03-16 20:54:23.608868600 -0700
@@ -21,14 +21,17 @@
 
 #include "ns3/names.h"
 #include "ns3/v4ping.h"
+#include "ns3/warnings.h"
 
 namespace ns3
 {
 
 V4PingHelper::V4PingHelper(Ipv4Address remote)
 {
+    NS_WARNING_PUSH_DEPRECATED;
     m_factory.SetTypeId("ns3::V4Ping");
     m_factory.Set("Remote", Ipv4AddressValue(remote));
+    NS_WARNING_POP;
 }
 
 void
@@ -65,10 +68,15 @@
 Ptr<Application>
 V4PingHelper::InstallPriv(Ptr<Node> node) const
 {
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
+
     Ptr<V4Ping> app = m_factory.Create<V4Ping>();
     node->AddApplication(app);
 
     return app;
+
+#pragma GCC diagnostic pop
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet-apps/helper/v4ping-helper.h ns-3.38/src/internet-apps/helper/v4ping-helper.h
--- ns-3.37/src/internet-apps/helper/v4ping-helper.h	2022-11-01 17:37:24.487395000 -0700
+++ ns-3.38/src/internet-apps/helper/v4ping-helper.h	2023-03-16 20:54:23.608868600 -0700
@@ -43,6 +43,7 @@
      *
      * \param remote The address which should be pinged
      */
+    NS_DEPRECATED_3_38("Use PingHelper instead - the attributes might have been renamed.")
     V4PingHelper(Ipv4Address remote);
 
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet-apps/model/ping6.cc ns-3.38/src/internet-apps/model/ping6.cc
--- ns-3.37/src/internet-apps/model/ping6.cc	2022-11-01 17:37:24.491395000 -0700
+++ ns-3.38/src/internet-apps/model/ping6.cc	2023-03-16 20:54:23.608868600 -0700
@@ -42,35 +42,37 @@
 TypeId
 Ping6::GetTypeId()
 {
-    static TypeId tid = TypeId("ns3::Ping6")
-                            .SetParent<Application>()
-                            .SetGroupName("Internet-Apps")
-                            .AddConstructor<Ping6>()
-                            .AddAttribute("MaxPackets",
-                                          "The maximum number of packets the application will send",
-                                          UintegerValue(100),
-                                          MakeUintegerAccessor(&Ping6::m_count),
-                                          MakeUintegerChecker<uint32_t>())
-                            .AddAttribute("Interval",
-                                          "The time to wait between packets",
-                                          TimeValue(Seconds(1.0)),
-                                          MakeTimeAccessor(&Ping6::m_interval),
-                                          MakeTimeChecker())
-                            .AddAttribute("RemoteIpv6",
-                                          "The Ipv6Address of the outbound packets",
-                                          Ipv6AddressValue(),
-                                          MakeIpv6AddressAccessor(&Ping6::m_peerAddress),
-                                          MakeIpv6AddressChecker())
-                            .AddAttribute("LocalIpv6",
-                                          "Local Ipv6Address of the sender",
-                                          Ipv6AddressValue(),
-                                          MakeIpv6AddressAccessor(&Ping6::m_localAddress),
-                                          MakeIpv6AddressChecker())
-                            .AddAttribute("PacketSize",
-                                          "Size of packets generated",
-                                          UintegerValue(100),
-                                          MakeUintegerAccessor(&Ping6::m_size),
-                                          MakeUintegerChecker<uint32_t>());
+    static TypeId tid =
+        TypeId("ns3::Ping6")
+            .SetParent<Application>()
+            .SetGroupName("Internet-Apps")
+            .AddConstructor<Ping6>()
+            .AddAttribute(
+                "MaxPackets",
+                "The maximum number of packets the application will send (zero means infinite)",
+                UintegerValue(100),
+                MakeUintegerAccessor(&Ping6::m_count),
+                MakeUintegerChecker<uint32_t>())
+            .AddAttribute("Interval",
+                          "The time to wait between packets",
+                          TimeValue(Seconds(1.0)),
+                          MakeTimeAccessor(&Ping6::m_interval),
+                          MakeTimeChecker())
+            .AddAttribute("RemoteIpv6",
+                          "The Ipv6Address of the outbound packets",
+                          Ipv6AddressValue(),
+                          MakeIpv6AddressAccessor(&Ping6::m_peerAddress),
+                          MakeIpv6AddressChecker())
+            .AddAttribute("LocalIpv6",
+                          "Local Ipv6Address of the sender",
+                          Ipv6AddressValue(),
+                          MakeIpv6AddressAccessor(&Ping6::m_localAddress),
+                          MakeIpv6AddressChecker())
+            .AddAttribute("PacketSize",
+                          "Size of packets generated",
+                          UintegerValue(100),
+                          MakeUintegerAccessor(&Ping6::m_size),
+                          MakeUintegerChecker<uint32_t>());
     return tid;
 }
 
@@ -230,7 +232,7 @@
     m_socket->Bind(Inet6SocketAddress(src, 0));
 
     /* use Loose Routing (routing type 0) */
-    if (m_routers.size())
+    if (!m_routers.empty())
     {
         Ipv6ExtensionLooseRoutingHeader routingHeader;
         routingHeader.SetNextHeader(Ipv6Header::IPV6_ICMPV6);
@@ -246,7 +248,7 @@
 
     NS_LOG_INFO("Sent " << p->GetSize() << " bytes to " << m_peerAddress);
 
-    if (m_sent < m_count)
+    if (m_sent < m_count || m_count == 0)
     {
         ScheduleTransmit(m_interval);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/internet-apps/model/ping6.h ns-3.38/src/internet-apps/model/ping6.h
--- ns-3.37/src/internet-apps/model/ping6.h	2022-11-01 17:37:24.491395000 -0700
+++ ns-3.38/src/internet-apps/model/ping6.h	2023-03-16 20:54:23.608868600 -0700
@@ -39,7 +39,8 @@
  * \ingroup ping6
  * \brief A ping6 application.
  */
-class Ping6 : public Application
+class NS_DEPRECATED_3_38("Use Ping instead - the attributes might have been renamed.") Ping6
+    : public Application
 {
   public:
     /**
